import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import org.apache.trax.*;
import org.xml.sax.InputSource;
import java.util.*;

public class ShowCatalog extends HttpServlet {
   
    public void doGet(HttpServletRequest request,
                       HttpServletResponse response)
        throws IOException, ServletException
    {


    String target = request.getHeader("User-Agent");
 
    ResourceBundle media = ResourceBundle.getBundle("media");
    Enumeration browsers = media.getKeys();

    boolean found = false;

    String mediaStr = "";
    while (browsers.hasMoreElements() && !found) {
        String thisBrowser = (String)browsers.nextElement();
        if (target.indexOf(thisBrowser) > -1) {
            found = true;
            mediaStr = media.getString(thisBrowser);
        }	
    }
    String mimetype = "";
    if (mediaStr.equals("up")) {
        mimetype = "text/vnd.wap.wml";
    } else {
        mimetype = "text/html";
    }
    response.setContentType(mimetype);
    PrintWriter out = response.getWriter();

    try {

        Processor processor = Processor.newInstance("xslt");

        InputSource[] XSLSheet = 
             processor.getAssociatedStylesheets(
               new InputSource("file:///c:/files/products.xml"), 
                                           mediaStr, null, null);

        Templates templates = processor.processMultiple(XSLSheet);

        Templates templates;
        try {
            templates = processor.processMultiple(XSLSheet);
        } catch (Exception e) {
	    XSLSheet = processor.getAssociatedStylesheets(
                new InputSource("file:///c:/files/products.xml"), 
                                               null, null, null);
	    templates = processor.processMultiple(XSLSheet);
        }

        Transformer transformer = templates.newTransformer();
        transformer.transform(
              new InputSource("file:///c:/files/products.xml"), 
                                                new Result(out));

    } catch (Exception e) { 
        out.print("There was a problem transforming the file.");
    }

    }
}
