import java.sql.*;

public class CreateTable {

  public static void main(String[] args) {
      try {
          Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
      } catch (ClassNotFoundException e) {
          System.out.println("There was a problem loading " +
               "the database driver.");
          return;

      }

      Connection furnDB = null;

      try {
          String URL = "jdbc:odbc:furniture";
          String username = "";
          String password = "";

          furnDB = DriverManager.getConnection (URL,
                                                  username,
                                                  password);
      } catch (SQLException e) {
          System.out.println("There was a problem connecting to " +
               "the database.");
      Connection furnDB = null;

      }

      try {

          Statement sql = furnDB.createStatement();

          String sqlTxt = "create table inventory ("+
                          "product_id text,"+
                          "location text,"+
                          "color text,"+
                          "inv number)";

          sql.execute(sqlTxt);

      } catch (SQLException e) {
          System.out.print("Error executing SQL: "
                + e.getMessage());
          return;
      }

      try {
          furnDB.close();
      } catch (SQLException e) {
          System.out.print("Couldn't close database.");
      }

  }

}
