import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;

public class DetectBrowser extends HttpServlet {

    public void doGet(HttpServletRequest request,
                      HttpServletResponse response)
        throws IOException, ServletException
   {
        response.setContentType("text/html");
        PrintWriter out = response.getWriter();

        out.print("<html>");
        out.print("<body>");

        String target = request.getHeader("User-Agent");
        out.print("<p>"+target+"</p>");
        ResourceBundle media = ResourceBundle.getBundle("media");
        Enumeration browsers = media.getKeys();
        boolean found = false;
        while (browsers.hasMoreElements() && !found) {
            String thisBrowser = (String)browsers.nextElement();
            if (target.indexOf(thisBrowser) > -1) {
                found = true;
                out.print("It IS "+media.getString(thisBrowser));
            } else {
                out.print("It isn't "
                           +media.getString(thisBrowser)+"<br />");
            }	
        }
        out.print("</body>");
        out.print("</html>");
    }
}
