<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

<xsl:template match="/">
<HTML>
<HEAD><TITLE>Vendor and Product Listings</TITLE></HEAD>
<BODY>
     <xsl:apply-templates/>
</BODY>
</HTML>

</xsl:template>

<xsl:template match="product">
  <xsl:choose>
  <xsl:when test="..[@webvendor='full']">
    <UL><LI>
        <xsl:apply-templates select="product_id"/>
        <xsl:value-of select="short_desc"/>
        <BR/><xsl:apply-templates select="inventory[@color]"/>
        <P><xsl:value-of select=".//price[@pricetype='sale'] |
                        .//price[@pricetype ='retail']"/></P>
    </LI></UL>
  </xsl:when>
  <xsl:when test="..[@webvendor='partial']">
          <xsl:value-of select="short_desc"/><BR/>
  </xsl:when>
  </xsl:choose>

</xsl:template>

<xsl:template match="product/product_id">
    <xsl:value-of select="."/>:
</xsl:template>




</xsl:stylesheet>
